// keppenDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "keppen.h"
#include "keppenDlg.h"
#include "Weather.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeppenDlg _CAO

CKeppenDlg::CKeppenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeppenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeppenDlg)
	m_Rain = _T("");
	m_Tem = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeppenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeppenDlg)
	DDX_Text(pDX, IDC_R, m_Rain);
	DDX_Text(pDX, IDC_T, m_Tem);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeppenDlg, CDialog)
	//{{AFX_MSG_MAP(CKeppenDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_K, OnK)
	ON_BN_CLICKED(IDC_FK, OnFk)
	ON_BN_CLICKED(IDC_GK, OnGk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeppenDlg bZ[W nh

BOOL CKeppenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	DragAcceptFiles(TRUE);
	
	return TRUE;
}

void CKeppenDlg::OnPaint() 
{
	if( IsIconic() )
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}

HCURSOR CKeppenDlg::OnQueryDragIcon()
{
	return (HCURSOR)m_hIcon;
}

void CKeppenDlg::OnK() 
{
	UpdateData(TRUE);

	CWeather w;
	sscanf(m_Tem.GetBuffer(0),"%f %f %f %f %f %f %f %f %f %f %f %f",&w.m_T[1],&w.m_T[2],&w.m_T[3],&w.m_T[4],&w.m_T[5],&w.m_T[6],&w.m_T[7],&w.m_T[8],&w.m_T[9],&w.m_T[10],&w.m_T[11],&w.m_T[12]);
	sscanf(m_Rain.GetBuffer(0),"%f %f %f %f %f %f %f %f %f %f %f %f",&w.m_R[1],&w.m_R[2],&w.m_R[3],&w.m_R[4],&w.m_R[5],&w.m_R[6],&w.m_R[7],&w.m_R[8],&w.m_R[9],&w.m_R[10],&w.m_R[11],&w.m_R[12]);
	w.Init();

	CString str;
	w.CalcStr(str);
	AfxMessageBox(str);
}

void CKeppenDlg::DoFile(CString& FileName)
{
	if( mp3.IsAble() )
	{
		if( mp3.Open(FileName) )
		{
			mp3.Play();
			m_Tem.Format( " %s / %s " , mp3.Info().szTrackName , mp3.Info().szArtistName );
			m_Rain.Format( "TOTALTIME( %d:%02d:%02d )" , mp3.Info().totalSec/3600,
								(mp3.Info().totalSec%3600)/60,mp3.Info().totalSec%60 );
			UpdateData(FALSE);
			return;
		}
	}

	CWeather w;
	CStdioFile f( FileName,CFile::modeReadWrite|CFile::typeText );

	CString str,str2;
	char* pStr;
	char Name[1000];
	int i;

	while( f.ReadString(str) )
	{
		pStr = str.GetBuffer(0);
		i=0;
		while( (*pStr)!=',' && (*pStr)!='\0' )
		{
			Name[i]=*pStr;
			pStr++;
			i++;
		}
		Name[i]='\0';
		pStr++;

		sscanf(pStr," %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f , %f",
					&w.m_T[1],&w.m_T[2],&w.m_T[3],&w.m_T[4],&w.m_T[5],&w.m_T[6],&w.m_T[7],&w.m_T[8],&w.m_T[9],&w.m_T[10],&w.m_T[11],&w.m_T[12],
					&w.m_R[1],&w.m_R[2],&w.m_R[3],&w.m_R[4],&w.m_R[5],&w.m_R[6],&w.m_R[7],&w.m_R[8],&w.m_R[9],&w.m_R[10],&w.m_R[11],&w.m_R[12]
				);
		w.Init();
		w.CalcStr(str2);
		str = Name;
		str += " ̋C敪 " + str2;
		if( IDCANCEL==AfxMessageBox(str,MB_OKCANCEL) )
			break;
	}
}

void CKeppenDlg::OnDropFiles(HDROP hDropInfo) 
{
	SetForegroundWindow();
	char str[256];
	DragQueryFile(hDropInfo,0,str,256);
	DragFinish(hDropInfo);
	DoFile(CString(str));
}

void CKeppenDlg::OnFk() 
{
	CString filter = "R}؂eLXg(*.csv)|*.csv|SẴt@C(*.*)|*.*||";
	CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,filter);
	dlg.m_ofn.lpstrTitle = "f[^t@CIłB";

	if( dlg.DoModal()==IDOK )
		DoFile(dlg.GetPathName());
}

#define LEFT (40)
#define WIDTH (240)
#define HEIGHT (240)

#define MAXRAIN (500)
#define MAXTEMP (40)
#define MINTEMP (-20)

LRESULT CALLBACK GraphProc(HWND wnd, UINT msg, WPARAM wp, LPARAM lp)
{
	float* pData = (float*)GetWindowLong( wnd , GWL_USERDATA );
	float *pT = pData , *pR = pData+13;

	switch( msg )
	{
	case WM_CREATE:
		{
			pData = new float[26];
			for( int i=0; i!=26; i++ )pData[i]=0;
			SetWindowLong( wnd , GWL_USERDATA , (long)(pData) );
		}
		break;
	case WM_DESTROY:
		delete [] pData;
		break;
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint( wnd,&ps );
			if( ps.fErase )
				FillRect(hdc,&ps.rcPaint,(HBRUSH)GetStockObject(WHITE_BRUSH));
			RECT rect={LEFT,0,LEFT+WIDTH,HEIGHT};
			FillRect(hdc,&rect,(HBRUSH)GetStockObject(WHITE_BRUSH));

			//  ////////////////////////
			HBRUSH br = CreateSolidBrush( RGB(120,180,255) );
			RECT rc = {LEFT+2,0,LEFT+-2+WIDTH/12,HEIGHT};
			for( int i=1; i!=13; i++ )
			{
				rc.top = (long)(HEIGHT - pR[i]*HEIGHT/MAXRAIN);
				FillRect(hdc,&rc,br);
				rc.left += WIDTH/12;
				rc.right += WIDTH/12;
			}
			DeleteObject(br);
			////////////////////////////////

			//  //////////////////////
			HPEN pn = CreatePen( PS_SOLID,0,RGB(255,0,0) );
			HPEN oldpn = (HPEN)SelectObject( hdc,pn );
			int x = LEFT+WIDTH/12/2;
			int y = (long)(HEIGHT - (pT[1]-MINTEMP)*HEIGHT/(MAXTEMP-MINTEMP));
			MoveToEx(hdc,x,y,NULL);
			for( int j=2; j!=13; j++ )
			{
				x+=WIDTH/12;
				y = (long)(HEIGHT - (pT[j]-MINTEMP)*HEIGHT/(MAXTEMP-MINTEMP));
				LineTo(hdc,x,y);
			}
			SelectObject( hdc,oldpn );
			DeleteObject(pn);
			////////////////////////////////

			//  ////////////////////////
			SetBkMode(hdc,TRANSPARENT);
			SetTextColor(hdc,RGB(0,0,0));
			HFONT font = CreateFont( 14,7,0,0,0,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,
										CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FIXED_PITCH|FF_DONTCARE,
										"FixedSys");
			HFONT oldfont = (HFONT)SelectObject(hdc,font);

			char month[]="PQRSTUVWX101112";
			for( int k=0;k!=12;k++ )
				TextOut( hdc ,LEFT+WIDTH*k/12,HEIGHT,&month[2*k],2 );
			TextOut( hdc ,0,0,"",2 );
			TextOut( hdc ,LEFT+WIDTH+10,0,"mm",2 );
			for( k=0;k<MAXRAIN;k+=100 )
			{
				char buf[10];
				itoa( k,buf,10 );
				TextOut( hdc ,LEFT+WIDTH,-7+(long)(HEIGHT - k*HEIGHT/MAXRAIN),buf,strlen(buf) );
			}
			for( k=MINTEMP;k<MAXTEMP;k+=10 )
			{
				char buf[10];
				itoa( k,buf,10 );
				TextOut( hdc ,LEFT-30,-7+(long)(HEIGHT - (k-MINTEMP)*HEIGHT/(MAXTEMP-MINTEMP)),buf,strlen(buf) );
			}

			CString str;
			CWeather w;
			memcpy( w.m_T , pT , sizeof(float)*13 );
			memcpy( w.m_R , pR , sizeof(float)*13 );
			w.Init();	w.CalcStr(str);
			TextOut( hdc ,LEFT+2,0,str,str.GetLength() );

			SelectObject(hdc,oldfont);
			////////////////////////////////

			EndPaint( wnd,&ps );
		}
		break;
	case WM_RBUTTONDOWN:
		{
			for( int i=1; i!=13; i++ )
			{
				if( LEFT+(i-1)*WIDTH/12 < LOWORD(lp) && LOWORD(lp) < LEFT+i*WIDTH/12 )
					break;
			}
			if( i==13 )	break;

			pR[i] = ((float)(HEIGHT-HIWORD(lp)))/HEIGHT*MAXRAIN;
			InvalidateRect(wnd,NULL,TRUE);
		}
 		break;
	case WM_LBUTTONDOWN:
		{
			for( int i=1; i!=13; i++ )
			{
				if( LEFT+(i-1)*WIDTH/12 < LOWORD(lp) && LOWORD(lp) < LEFT+i*WIDTH/12 )
					break;
			}
			if( i==13 )	break;

			pT[i] = ((float)(HEIGHT-HIWORD(lp)))/HEIGHT*(MAXTEMP-MINTEMP)+MINTEMP;
			InvalidateRect(wnd,NULL,TRUE);
		}
		break;
	default:
		return DefWindowProc(wnd,msg,wp,lp);
	}
	return 0L;
}

void CKeppenDlg::OnGk() 
{
	WNDCLASS wc;
	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC)GraphProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= AfxGetInstanceHandle();
	wc.hIcon			= 0;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= "Graph Window";
	RegisterClass( &wc );

	HWND hwnd = CreateWindowEx(
					WS_EX_TOOLWINDOW,
					wc.lpszClassName,"Ot",
					WS_VISIBLE|WS_POPUPWINDOW|WS_CAPTION, 100, 100, 320, 280,
					GetSafeHwnd(),NULL,NULL,AfxGetInstanceHandle());

	::UpdateWindow(hwnd);
}
